
/*
   Copyright (C) 1994 Moir Brandts Honk
   Distributed under license by the Free Software Foundation, Inc.

This file is part of MBH PEX development kit.

MBH PEX LIB is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

MBH PEX LIB is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with MBH PEX LIB; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.

Report problems and direct all questions to:


Moir Brandts Honk      LINEA DATARUM & TABULA FIBULARUM       Moir Brandts Honk

    (sysop -[TJS]-)
    The Netherlands

    netmail:
         Fido: 2:281/522.7
         THANet Hub: 70:3170/100

    phone:
                USR/DS: +31-70-3461215
          ZyXEL 1496E+: +31-70-3457929
         LineLink 144e: +31-70-3452981

    Snail Mail:
         P.O. Box 709
         2501 CS  Den Haag
         The Netherlands

*/

/*
   NOTE:

   the following line must be removed (or commented out) in the
   headerfile

     pb_sdk.h

   ::

     void exit(void);

   (located near line 1130)
*/

/*--------------------------------------------------------------------
// Moir Brandts Honk                                Copyright (c) 1994
//--------------------------------------------------------------------
//
// Author : -[ TJS ]-

/*
 * $Log$
 */

#ifndef __PB_MBH_H_
#define __PB_MBH_H_

//--------------------------------------------------------------------
// Compiler specific include files
//--------------------------------------------------------------------
// FORBIDDEN!

//--------------------------------------------------------------------
// Third Party include files
//--------------------------------------------------------------------
#include <pb_sdk.h>

//--------------------------------------------------------------------
// MBH general include files
//--------------------------------------------------------------------

//--------------------------------------------------------------------
// Program specific include files
//--------------------------------------------------------------------

//--------------------------------------------------------------------

/*
   EXTERN type variable IS(startup value);

   one definition in the header file, one location where dataspace
   is declared (#define _PB_MBH_H)
*/

#ifdef  _PB_MBH_H
#define EXTERN
#define IS(x) = x
#define ARRINT
#else
#define EXTERN extern
#define IS(x)
#undef  ARRINT
#endif

//--------------------------------------------------------------------
// Defines
//--------------------------------------------------------------------
#undef TRUE
#undef FALSE

#define FALSE 0
#define TRUE  (!FALSE)

#define EOF (-1)
//--------------------------------------------------------------------
// Type definitions
//--------------------------------------------------------------------

typedef void cdecl (*atexit_t)(void);

/*
   this structure defines the data displayed when a PEX file is renamed
   to .EXE and run directly from the DOS commandline.

   Ideas for use:

   - message about use of the PEX file.
   - manual page
   - banners ;-)
*/
typedef struct
{
  unsigned int size;        /* the real size of the message */
  const char *message;      /* the message itself */
} PB_DOS_Message_Struct;

//--------------------------------------------------------------------
// Global variables
//--------------------------------------------------------------------

/*
   seemingly unused space between various Proboard variables is listed here...
*/

extern unsigned short _unknown_dat_01; // undocumented Proboard variable(s)
extern unsigned short _unknown_dat_02; // undocumented Proboard variable(s)
extern unsigned char  _unknown_dat_03; // undocumented Proboard variable(s)
extern unsigned short _unknown_dat_04; // undocumented Proboard variable(s)
extern unsigned char  _unknown_dat_05; // undocumented Proboard variable(s)
extern unsigned short _unknown_dat_06; // undocumented Proboard variable(s)
extern unsigned short _unknown_dat_07; // undocumented Proboard variable(s)
extern unsigned short _unknown_dat_10; // undocumented Proboard variable(s)
extern unsigned short _unknown_dat_08; // undocumented Proboard variable(s)
extern unsigned short _unknown_dat_09; // undocumented Proboard variable(s)

/*
   extra variables which are reserved for future use...
*/

extern long _fut_dat_06;    /* future use, NOT IMPLEMENTED YET */
extern long _fut_dat_07;    /* future use, NOT IMPLEMENTED YET */
extern long _fut_dat_08;    /* future use, NOT IMPLEMENTED YET */
extern long _fut_dat_09;    /* future use, NOT IMPLEMENTED YET */
extern long _fut_dat_10;    /* future use, NOT IMPLEMENTED YET */
extern long _fut_dat_11;    /* future use, NOT IMPLEMENTED YET */
extern long _fut_dat_12;    /* future use, NOT IMPLEMENTED YET */
extern long _fut_dat_13;    /* future use, NOT IMPLEMENTED YET */
extern long _fut_dat_14;    /* future use, NOT IMPLEMENTED YET */
extern long _fut_dat_15;    /* future use, NOT IMPLEMENTED YET */
extern long _fut_dat_16;    /* future use, NOT IMPLEMENTED YET */
extern long _fut_dat_17;    /* future use, NOT IMPLEMENTED YET */
extern long _fut_dat_18;    /* future use, NOT IMPLEMENTED YET */
extern long _fut_dat_19;    /* future use, NOT IMPLEMENTED YET */
extern long _fut_dat_20;    /* future use, NOT IMPLEMENTED YET */

extern PB_DOS_Message_Struct *PB_DOS_Message;

/*
  NOTE: begin of Proboard datablock starts with the variable 'CurUser'
*/

//--------------------------------------------------------------------
// Prototypes
//--------------------------------------------------------------------
#ifdef __cplusplus
extern "C" {
#endif

  void exit(int exitvalue); /* exitvalue is unused... */

  /*
     Proboard UNDOCUMENTED functions
  */
  void ResetInactivity();   /* reset inactivity timer ??? */
  void RestoreHandler(int handler, HANDLER *hnd);   /* commented-out in PB_SDK.H */
  void ___exit(int);        /* exit without executing the atexit() functions */
  void filesize();          /* determine filesize */

  /*
     Proboard function locations reserved for future use
  */

  void ___bsearch();        /* future use, NOT YET IMPLEMENTED */
  void ___qsort();          /* future use, NOT YET IMPLEMENTED */

  void _fut_func_3();       /* future use, NOT IMPLEMENTED YET */
  void _fut_func_4();       /* future use, NOT IMPLEMENTED YET */
  void _fut_func_5();       /* future use, NOT IMPLEMENTED YET */
  void _fut_func_6();       /* future use, NOT IMPLEMENTED YET */
  void _fut_func_7();       /* future use, NOT IMPLEMENTED YET */
  void _fut_func_8();       /* future use, NOT IMPLEMENTED YET */
  void _fut_func_9();       /* future use, NOT IMPLEMENTED YET */
  void _fut_func_10();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_11();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_12();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_13();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_14();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_15();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_16();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_17();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_18();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_19();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_20();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_21();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_22();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_23();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_24();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_25();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_26();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_27();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_28();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_29();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_30();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_31();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_32();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_33();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_34();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_35();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_36();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_37();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_38();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_39();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_40();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_41();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_42();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_43();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_44();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_45();      /* future use, NOT IMPLEMENTED YET */
  void _fut_func_46();      /* future use, NOT IMPLEMENTED YET */


  /*
     extra additions to the proboard library
  */

  int cdecl atexit(atexit_t func);

#ifdef __cplusplus
}
#endif

//--------------------------------------------------------------------
#undef EXTERN
#undef IS(x)
#undef ARRINT
#endif  __PB_MBH_H_

//-END-OF-FILE--------------------------------------------------------


